﻿using FlutterCodeGenerator.Helper;
using System;

namespace FlutterCodeGenerator.ModelTypes
{
    internal class ArrayModelType : SimpleModelType
    {
        public ModelType Child;

        public ArrayModelType(Type type, string name) : base(type, name)
        {
            var arrayTypeName = ParameterType.FullName.Replace("[]", string.Empty);
            var arrayType = ParameterType.Assembly.GetType(arrayTypeName);
            Child = ModelTypeGenerator.Create(arrayType, "");
        }

        public override string GetFlutterTypeName(bool isDefault = true, bool isGenericName = false, bool isSingle = false)
        {
            var parameterTypeName = Child.GetFlutterTypeName();
            if (Index > 1)
            {
                return $"List<{parameterTypeName}{Index}>";
            }
            else
            {
                return $"List<{parameterTypeName}>";
            }
        }
    }
}