﻿using FlutterCodeGenerator.Helper;
using System;

namespace FlutterCodeGenerator.ModelTypes
{
    internal class ModelType
    {
        public Type ParameterType { get; set; }

        /// <summary>
        ///Name(First Character Lower Case)
        /// </summary>
        public string Name_Lower { get; set; }

        /// <summary>
        ///Name(First Character Upper Case)
        /// </summary>
        public string Name_Upper { get; set; }

        public string DefaultValue { get; set; }

        /// <summary>
        /// Index(For Same Name)
        /// </summary>
        public int Index { get; set; }

        public ModelType(Type type, string name)
        {
            ParameterType = type;
            Name_Lower = LetterConverterHelper.FirstCharToLower(name);
            Name_Upper = LetterConverterHelper.FirstCharToUpper(name);
            DefaultValue = null;
            Index = 1;
        }

        public virtual string GetFlutterTypeName(bool isDefault = true, bool isGenericName = false, bool isSingle = false)
        {
            return ParameterType.Name;
        }

        public virtual string GetDartString()
        {
            return string.Empty;
        }

        protected string QuestionMarkCheck(ModelType child)
        {
            if (child.DefaultValue != null)
            {
                return "";
            }
            else
            {
                return "?";
            }
        }
    }
}