﻿using FlutterCodeGenerator.Helper;
using System;
using System.IO;

namespace FlutterCodeGenerator
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            try
            {
                var generatedFolderPath = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "GeneratedCode");
                var dllPath = AppDomain.CurrentDomain.BaseDirectory;
                if (args.Length == 2)
                {
                    dllPath = args[0];
                    generatedFolderPath = args[1];
                }
                if (string.IsNullOrWhiteSpace(dllPath) || string.IsNullOrWhiteSpace(generatedFolderPath))
                {
                    throw new ArgumentException("The argments are invalid！");
                }
                var codeGenerator = new CodeGenerator(dllPath, generatedFolderPath);
                codeGenerator.GeneratedCode();
                Console.WriteLine($"The code has already generated! The path is {generatedFolderPath}");
            }
            catch (Exception ex)
            {
                Console.WriteLine($"An Error occured when generated!!! Error Message : {ex}");
            }
            Console.ReadLine();
        }
    }
}